<!-- app/views/devise/registrations/new.html.erb -->

<%= form_for(resource, as: resource_name, url: registration_path(resource_name)) do |f| %>
  <!-- other registration fields -->

  <% if current_user&.admin? %>
    <div class="field">
      <%= f.label :role %><br />
      <%= f.select :role, User.roles.keys.map { |role| [role.titleize, role] }, {}, { class: 'select' } %>
    </div>
  <% end %>

  <!-- more code... -->
<% end %>